package fr.jelora;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import jssc.SerialPort;
import jssc.SerialPortException;

public class Test {

	public static void main(String[] args) {
		Test test = new Test();
		test.start();
	}

	public void start() {
		try {
			SerialPort serialPort = new SerialPort("/dev/ttyAMA0");
			serialPort.openPort();
			serialPort.setParams(1200, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
			
			SimpleDateFormat formatterDateHeureMessageAppel = new SimpleDateFormat("MMddHHmm");
			SimpleDateFormat formatterAffichage = new SimpleDateFormat("dd/MM/YYYY HH:mm");
			
			boolean messageEnCours = false;
			int comptage55 = 0;
			TypeMessage typeMessage = null;
			int longueurMessage = 0;
			int avancementLectureMessage = 0;
			ParametreMessage parametreMessage = null;
			int longueurParametre = 0;
			int avancementLectureParametre = 0;
			StringBuilder valeurParametre = null;
			boolean parametreEnCours = false;
			byte carac;
			while (true) {
				carac = this.readByte(serialPort);
				//System.out.print(carac + "");
				//System.out.println(this.toHex(carac) + ": " + (char) carac);
				//System.out.println(messageEnCours);
				
				if ( !messageEnCours ){
					// Attente d'un message
					if ( carac == 0x55 ){
						// Détection début message
						comptage55++;
					}
					else{
						// Fin détection début message
						if ( carac == (byte) 0xd5 && comptage55 > 25 ){
							messageEnCours = true;
							typeMessage = null;
							System.out.println("Début d'un message");
						}
						comptage55 = 0;
					}
				}
				else{
					if ( typeMessage == null ){
						// Message déctecté
						// Déterminaison du type de message
						System.out.print("Type message: ");
						if ( carac == TypeMessage.MessageDAppel.code ){
							System.out.println("Message d'appel (" + this.toHex(carac) + ")");
							typeMessage = TypeMessage.MessageDAppel;
						}
						else{
							messageEnCours = false;
							System.out.println("Incorrect");
						}
						longueurMessage = 0;
					}
					else{
						// Type de message détecté
						if ( longueurMessage == 0 ){
							// Récupération longeur
							longueurMessage = carac;
							if ( longueurMessage == 0 ){
								messageEnCours = false;
								typeMessage = null;
							}
							System.out.println("Longueur: " + longueurMessage);
							parametreMessage = null;
							parametreEnCours = false;
							avancementLectureMessage = 0;
						}
						else{
							// Longeur message récupérée >1
							
							if ( !parametreEnCours ){
								// Déterminaison du type de paramètre
								parametreMessage = null;
								System.out.print("> Paramètre: ");
								if ( carac == ParametreMessage.MessageDAppelDateHeure.code ){
									parametreMessage = ParametreMessage.MessageDAppelDateHeure;
								}
								else if ( carac == ParametreMessage.MessageDAppelIdentiteDuDemandeur.code ){
									parametreMessage = ParametreMessage.MessageDAppelIdentiteDuDemandeur;
								}
								else if ( carac == ParametreMessage.MessageDAppelRaisonAbsenceIdentiteDuDemandeur.code ){
									parametreMessage = ParametreMessage.MessageDAppelRaisonAbsenceIdentiteDuDemandeur;
								}
								
								if ( parametreMessage != null ){
									System.out.print(parametreMessage.titre);
								}
								else{
									System.out.print("Inconnu");
								}
								System.out.println(" (" + this.toHex(carac) + ")");
								parametreEnCours = true;
								longueurParametre = 0;
							}
							else{
								// Il y a un paramètre en cours (type déterminé ou non)
								if ( longueurParametre == 0 ){
									// Récupération longeur
									longueurParametre = carac;
									System.out.println("> > Longueur: " + longueurParametre);
									avancementLectureParametre = 0;
									valeurParametre = new StringBuilder();
								}
								else{
									// Le paramètre a une longeur >1
									valeurParametre.append((char) carac);
									avancementLectureParametre++;
									if ( avancementLectureParametre == longueurParametre ){
										System.out.print("> > Valeur: " + valeurParametre.toString() + " ");
										if ( parametreMessage == ParametreMessage.MessageDAppelDateHeure ){
											Calendar calendarEnCours = Calendar.getInstance();
											
											Calendar calendar = Calendar.getInstance();
											calendar.setTime(formatterDateHeureMessageAppel.parse(valeurParametre.toString()));
											calendar.set(Calendar.YEAR, calendarEnCours.get(Calendar.YEAR));
												
											System.out.println("(" + formatterAffichage.format(calendar.getTime()) + ")");
										}
										else if ( parametreMessage == ParametreMessage.MessageDAppelIdentiteDuDemandeur ){
											// RAF de particulier
											System.out.println("");
										}
										else if ( parametreMessage == ParametreMessage.MessageDAppelRaisonAbsenceIdentiteDuDemandeur ){
											if ( valeurParametre.toString().equals("O") ){
												System.out.println("(Indisponible)");
											}
											if ( valeurParametre.toString().equals("P") ){
												System.out.println("(Secret invoqué)");
											}
										}
										else{
											System.out.println("");
										}
											
										// Paramètre terminé
										parametreEnCours = false;
									}
								}
							}
							
							avancementLectureMessage++;
							if ( avancementLectureMessage >= longueurMessage ){
								// Message terminé
								System.out.println("Fin du message");
								System.out.println("> Checksum: " + this.toHex(carac) + "\n");
								messageEnCours = false;
								typeMessage = null;
							}
						}
					}
				}
			}

			//serialPortReader.closePort();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	private byte readByte(SerialPort serialPort) throws SerialPortException {
		byte[] caracs = serialPort.readBytes(1);
		return caracs[0];
	}

	private String toHex(byte carac) {
		String hex = Integer.toHexString(0xff & carac);
		if ( hex.length() == 1 ){
			hex = "0" + hex;
		}
		return hex;
	}
	
	private enum TypeMessage {
		MessageDAppel((byte)0x80);
		
		byte code;
		private TypeMessage (byte code){
			this.code = code;
		}
	}
	
	private enum ParametreMessage {
		MessageDAppelDateHeure((byte)0x01, "Date/Heure"),
		MessageDAppelIdentiteDuDemandeur((byte)0x02, "Identité du demandeur"),
		MessageDAppelRaisonAbsenceIdentiteDuDemandeur((byte)0x04, "Raison de l'absence de l'identité du demandeur");
		
		byte code;
		String titre;
		private ParametreMessage (byte code, String titre){
			this.titre = titre;
			this.code = code;
		}
		
	}
}
